// FlashFile.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <iobase.h>
 
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	OutputDebugString( TEXT( "FlashFile started!" ) );

	// Set thread priority to highest. This dramatically improves scan consistency.
	//
	SetThreadPriority( GetCurrentThread(), THREAD_PRIORITY_TIME_CRITICAL );

	// Create and initialize the I/O base interface
	//
	CIOBase IOB;

	// Turn on the run mode LED
	//
	IOB.TurnOnRunLED();	

	// Create a file on the FLASH drive
	//
	HANDLE h= CreateFile( TEXT( "\\FlashDrive\\Testfile.Txt" ), GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL );
 
	if( h != INVALID_HANDLE_VALUE )
	{
		BYTE Buffer[100];
		
		int x;
		
		DWORD dWord;
 
		RETAILMSG( 1, ( TEXT( "\n CreateFile Success!\n" ) ) );
 
		// Now lets fill the file with useless data
		//
		for( x= 0; x < sizeof( Buffer ); x++ )
			Buffer[x]= x;
 
		if( !WriteFile( h, Buffer, sizeof( Buffer ), &dWord, NULL ) )
			RETAILMSG( 1, ( TEXT( "\n   WriteFile failed LastError: %d\n" ), GetLastError() ) );
		else
			RETAILMSG( 1, ( TEXT( "\n	WriteFile Success!\n") ) );
 
		CloseHandle( h );
 
		// Now lets reopen the file and see if what we wrote it actually still in there
		//
		h= CreateFile( TEXT( "\\FlashDrive\\test1.fil" ), GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL );
 
		if( h != INVALID_HANDLE_VALUE )
		{
			int Diffs= 0;
			memset( Buffer, 0, sizeof( Buffer ) );
 
			RETAILMSG( 1, ( TEXT( "\n OpenFile Success!\n") ) );
 
			if( !ReadFile( h, Buffer, sizeof( Buffer ), &dWord, NULL ) )
				RETAILMSG( 1, ( TEXT( "\n	ReadFile failed LastError: %d\n" ), GetLastError() ) );
			else
				RETAILMSG( 1, ( TEXT( "\n	ReadFile Success!\n") ) );
 
			for( x= 0; x< sizeof( Buffer ); x++ )
			{
				if( Buffer[x]!= x )
				{
					RETAILMSG( 1, ( TEXT( "\n		Buffer[x]== %d  x== %d\n" ), Buffer[x], x ) );
					Diffs++;
				}
			}
 
			if( Diffs )
				RETAILMSG( 1, ( TEXT( "\n	Total Differences: %d\n" ), Diffs ) );
			else
				RETAILMSG( 1, ( TEXT( "\n	Verify Success!\n" ) ) );
 
			CloseHandle( h );
		
		}else
			RETAILMSG( 1, ( TEXT( "\n OpenFile failed LastError: %d\n" ), GetLastError() ) );
	}else
	{
		RETAILMSG( 1, ( TEXT( "\nCreateFile failed LastError: %d\n" ), GetLastError() ) );
	}


	// Turn off the run mode LED
	//
	IOB.TurnOffRunLED();
	
	OutputDebugString( TEXT( "FlashFile exiting. Bye!" ) );

	return 0;
}


