#ifndef __MB_API_H
#define __MB_API_H

// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the MAILBOX_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// MAILBOX_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef MAILBOX_EXPORTS
#define MAILBOX_API __declspec(dllexport)
#else
#define MAILBOX_API __declspec(dllimport)
#endif


#ifdef __cplusplus
extern "C" {
#endif

typedef HANDLE HMBC;
typedef HANDLE HMAILBOX;

MAILBOX_API HMAILBOX CreateMailbox(WORD Port);
MAILBOX_API void DestroyMailbox(HMAILBOX hMB);

MAILBOX_API HMBC CreateConnection(HMAILBOX hMB, DWORD Address, WORD Timeout, WORD Retries);
MAILBOX_API HMBC CreateConnectionS(HMAILBOX hMB, WCHAR *pStr, WORD Timeout, WORD Retries);
MAILBOX_API void DestroyConnection(HMAILBOX hMB, HMBC hMBC);
MAILBOX_API BOOL CheckConnection(HMAILBOX hMB, HMBC hMBC);

MAILBOX_API BOOL SendMsg(HMAILBOX hMB, HMBC hMBC, BYTE *pData, WORD Length);
MAILBOX_API int IncomingMessagesAvailable(HMAILBOX hMB);
MAILBOX_API BOOL GetIncomingMessage(HMAILBOX hMB, BYTE *pData, WORD *pLength, DWORD *pSourceAddress);

#ifdef __cplusplus
}
#endif

#endif // __MB_API_H
