#ifdef WPLCRT_EXPORTS
#define WPLCRT_API __declspec(dllexport)
#else
#define WPLCRT_API __declspec(dllimport)
#endif

#define WPLC_RAPI_CREATEFILE						1
#define WPLC_RAPI_READFILE							2
#define WPLC_RAPI_WRITEFILE						3
#define WPLC_RAPI_GETLASTERROR					4
#define WPLC_RAPI_CLOSEHANDLE						5
#define WPLC_RAPI_SETCOMMSTATE					6
#define WPLC_RAPI_GETCOMMSTATE					7
#define WPLC_RAPI_SETCOMMTIMEOUTS				8
#define WPLC_RAPI_GETCOMMTIMEOUTS				9
#define WPLC_RAPI_SETLASTERROR					10

#define WPLC_RAPI_GETFILETIME						11
#define WPLC_RAPI_SETFILETIME						12
#define WPLC_RAPI_FINDFIRSTFILE					13
#define WPLC_RAPI_FINDCLOSE						14
#define WPLC_RAPI_FINDNEXTFILE					15
#define WPLC_RAPI_DELETEFILE						16
#define WPLC_RAPI_SETENDOFFILE					17
#define WPLC_RAPI_SETFILEPOINTER					18
#define WPLC_RAPI_FLUSHFILEBUFFERS				19
#define WPLC_RAPI_GETFILESIZE						20
#define WPLC_RAPI_CEOIDGETINFO					21
#define WPLC_RAPI_GETFILEINFORMATIONBYHANDLE	22
#define WPLC_RAPI_SETFILEATTRIBUTES				23
#define WPLC_RAPI_GETFILEATTRIBUTES				24
#define WPLC_RAPI_CREATEDIRECTORY				25
#define WPLC_RAPI_REMOVEDIRECTORY				26
#define WPLC_RAPI_PURGECOMM						27
#define WPLC_RAPI_CLEARCOMMERROR					28
#define WPLC_RAPI_GETCOMMPROPERTIES				29


typedef struct _FIND_DATAW {
    DWORD dwFileAttributes;
    FILETIME ftCreationTime;
    FILETIME ftLastAccessTime;
    FILETIME ftLastWriteTime;
    DWORD nFileSizeHigh;
    DWORD nFileSizeLow;
    DWORD dwOID;
    WCHAR cFileName[ MAX_PATH ];
} FIND_DATAW, *PFIND_DATAW, *LPFIND_DATAW;



#if defined(__cplusplus)
extern "C"
	{
#endif	/* #if defined(__cplusplus) */
/*
** WinPLC remote API functions.
*/
WPLCRT_API int WPLCCreateFile(HEIDevice *pDevice, BYTE *lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode, 
					DWORD dwCreationDistribution, DWORD dwFlagsAndAttributes, HANDLE *pRetVal);

// Read/Write file stuff
WPLCRT_API int WPLCReadFile(HEIDevice *pDevice,  HANDLE hFile, BYTE *lpBuffer, DWORD nNumberOfBytesToRead, DWORD *lpNumberOfBytesRead, BOOL *pRet);
WPLCRT_API int WPLCWriteFile(HEIDevice *pDevice,  HANDLE hFile, BYTE *lpBuffer, DWORD nNumberOfBytesToWrite, DWORD *lpNumberOfBytesWritten, BOOL *pRet);

// Error stuff
WPLCRT_API int WPLCGetLastError(HEIDevice *pDevice, DWORD *pRet);
WPLCRT_API int WPLCSetLastError(HEIDevice *pDevice, DWORD Value);

WPLCRT_API int WPLCCloseHandle(HEIDevice *pDevice,  HANDLE hObject, BOOL *pRet);

// Comm state stuff
WPLCRT_API int WPLCSetCommState(HEIDevice *pDevice, HANDLE hFile, DCB *lpDCB, BOOL *pRet);
WPLCRT_API int WPLCGetCommState(HEIDevice *pDevice, HANDLE hFile, DCB *lpDCB, BOOL *pRet);

// Comm timeout stuff
WPLCRT_API int WPLCSetCommTimeouts(HEIDevice *pDevice, HANDLE hFile, COMMTIMEOUTS *lpCommTimeouts, BOOL *pRet);
WPLCRT_API int WPLCGetCommTimeouts(HEIDevice *pDevice, HANDLE hFile, COMMTIMEOUTS *lpCommTimeouts, BOOL *pRet);


// File time stuff.
WPLCRT_API int WPLCGetFileTime(HEIDevice *pDevice,  HANDLE hFile, LPFILETIME lpCreationTime, LPFILETIME lpLastAccessTime, LPFILETIME lpLastWriteTime, BOOL *pRet); 
WPLCRT_API int WPLCSetFileTime(HEIDevice *pDevice,  HANDLE hFile, const FILETIME *lpCreationTime, const FILETIME *lpLastAccessTime, const FILETIME *lpLastWriteTime, BOOL *pRet); 

// Find file stuff
WPLCRT_API int WPLCFindFirstFile(HEIDevice *pDevice, LPCTSTR lpFileName, LPFIND_DATAW lpFindFileData, HANDLE *pRet); 
WPLCRT_API int WPLCFindClose(HEIDevice *pDevice,  HANDLE hFindFile, BOOL *pRet); 
WPLCRT_API int WPLCFindNextFile(HEIDevice *pDevice,  HANDLE hFindFile, LPFIND_DATAW lpFindFileData, BOOL *pRet); 

WPLCRT_API int WPLCDeleteFile(HEIDevice *pDevice, LPCTSTR lpFileName, BOOL *pRet);
WPLCRT_API int WPLCSetEndOfFile(HEIDevice *pDevice,  HANDLE hFile, BOOL *pRet);
WPLCRT_API int WPLCSetFilePointer(HEIDevice *pDevice,  HANDLE hFile, LONG lDistanceToMove, PLONG lpDistanceToMoveHigh, DWORD dwMoveMethod, DWORD *pRet); 
WPLCRT_API int WPLCFlushFileBuffers (HEIDevice *pDevice, HANDLE hFile, BOOL *pRet); 
WPLCRT_API int WPLCGetFileSize(HEIDevice *pDevice,  HANDLE hFile, LPDWORD lpFileSizeHigh, DWORD *pRet); 
WPLCRT_API int WPLCGetFileInformationByHandle(HEIDevice *pDevice,  HANDLE hFile, LPBY_HANDLE_FILE_INFORMATION lpFileInformation, BOOL *pRet);

// File Attribute stuff
WPLCRT_API int WPLCSetFileAttributes(HEIDevice *pDevice, LPCTSTR lpFileName, DWORD dwFileAttributes, BOOL *pRet); 
WPLCRT_API int WPLCGetFileAttributes(HEIDevice *pDevice, LPCTSTR lpFileName, DWORD *pRet); 

// Directory Stuff
WPLCRT_API int WPLCCreateDirectory(HEIDevice *pDevice, LPCTSTR lpPathName, LPSECURITY_ATTRIBUTES lpSecurityAttributes, BOOL *pRet); 
WPLCRT_API int WPLCRemoveDirectory(HEIDevice *pDevice, LPCTSTR lpPathName, BOOL *pRet); 

// Misc comm functions.
WPLCRT_API int WPLCPurgeComm(HEIDevice *pDevice, HANDLE hFile, DWORD dwFlags, BOOL *pRet); 
WPLCRT_API int WPLCClearCommError(HEIDevice *pDevice, HANDLE hFile, LPDWORD lpErrors, LPCOMSTAT lpStat, BOOL *pRet); 
WPLCRT_API int WPLCGetCommProperties(HEIDevice *pDevice, HANDLE hFile, LPCOMMPROP lpCommProp, BOOL *pRet); 


#if defined(__cplusplus)
	}
#endif	/* #if defined(__cplusplus) */
